%define anolis_release 2
%bcond_without tests

Name:           pyproject-rpm-macros
Version:        1.0.0
Release:        %{anolis_release}%{?dist}
Summary:        RPM macros for PEP 517 Python packages
License:        MIT
URL:            https://src.fedoraproject.org/rpms/pyproject-rpm-macros
Source001:      macros.pyproject
#Implementation files:
Source101:      pyproject_buildrequires.py
Source102:      pyproject_save_files.py
Source103:      pyproject_convert.py
Source104:      pyproject_preprocess_record.py
Source105:      pyproject_construct_toxenv.py
Source106:      pyproject_requirements_txt.py

#For Tests:
Source201:      test_pyproject_buildrequires.py
Source202:      test_pyproject_save_files.py
Source203:      test_pyproject_requirements_txt.py
Source204:      compare_mandata.py

#For test data
Source301:      pyproject_buildrequires_testcases.yaml
Source302:      pyproject_save_files_test_data.yaml
Source303:      test_RECORD

# Metadata
Source901:      README.md
Source902:      LICENSE

BuildArch:      noarch

%if %{with tests}
BuildRequires: python3dist(pytest) python3dist(pyyaml) python3dist(packaging)
BuildRequires: python3dist(pip) python3dist(setuptools) python3dist(toml)
BuildRequires: python3dist(tox-current-env) >= 0.0.6 python3dist(wheel)
%endif

Requires:      python-rpm-macros python-srpm-macros python3-rpm-macros
Requires:      /usr/bin/find /usr/bin/sed

%description
These macros allow projects that follow the Python packaging specifications
to be packaged as RPMs.

They work for:

* traditional Setuptools-based projects that use the setup.py file,
* newer Setuptools-based projects that have a setup.cfg file,
* general Python projects that use the PEP 517 pyproject.toml file
  (which allows using any build system, such as setuptools, flit or poetry).

These macros replace %%py3_build and %%py3_install,
which only work with setup.py.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -c -T
install -m 0644 -p %{sources} .

%build

%install
mkdir -p %{buildroot}%{_rpmmacrodir}
mkdir -p %{buildroot}%{_rpmconfigdir}/anolis
install -m 644 macros.pyproject %{buildroot}%{_rpmmacrodir}/
install -m 644 pyproject_buildrequires.py %{buildroot}%{_rpmconfigdir}/anolis/
install -m 644 pyproject_convert.py %{buildroot}%{_rpmconfigdir}/anolis/
install -m 644 pyproject_save_files.py  %{buildroot}%{_rpmconfigdir}/anolis/
install -m 644 pyproject_preprocess_record.py %{buildroot}%{_rpmconfigdir}/anolis/
install -m 644 pyproject_construct_toxenv.py %{buildroot}%{_rpmconfigdir}/anolis/
install -m 644 pyproject_requirements_txt.py %{buildroot}%{_rpmconfigdir}/anolis/

%if %{with tests}
%check
export HOSTNAME="rpmbuild"
%{python3} -m pytest -vv --doctest-modules
%{python3} compare_mandata.py -f %{_rpmconfigdir}/brp-compress
%endif


%files
%license LICENSE
%{_rpmmacrodir}/macros.pyproject
%{_rpmconfigdir}/anolis/pyproject_buildrequires.py
%{_rpmconfigdir}/anolis/pyproject_convert.py
%{_rpmconfigdir}/anolis/pyproject_save_files.py
%{_rpmconfigdir}/anolis/pyproject_preprocess_record.py
%{_rpmconfigdir}/anolis/pyproject_construct_toxenv.py
%{_rpmconfigdir}/anolis/pyproject_requirements_txt.py

%files doc
%doc README.md

%changelog
* Sat Apr 15 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 1.0.0-2
- Refact spec

* Thu Mar 03 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.0.0-1
- upstream version 1.0.0
